' Source File : Ion2BBS.Bas
' Object File : Ion2BBS.Exe
' Start Date  : 6/25/2014
' Author      : Benjamin E. Ritchey Jr.
' Description : Convert hybrid Description file to Files.BBS format
'               Copyright {c} 2014 by Ben Ritchey Jr., et al

  CLEAR ,,1024
  ON ERROR GOTO INTERROR
  STARTOFRUN!=TIMER: DIM MONTHTAB$(12): TIMEOUT=TIMER+60: SYSLOG=0
100 PNAME$=" Convert hybrid Descript.ion file to Files.BBS "
  FOR L=1 TO 12: READ MONTHTAB$(L): NEXT L
  IF SYSLOG THEN OPEN "ion2bbs.LOG" FOR OUTPUT AS #4

200 SCREEN 0,1,1,0 ' Text, Color, Active/Display Page
  WIDTH 80: KEY OFF: ' VIEW PRINT 1 TO 25
  COLOR 11: LOCATE 1,1
    PRINT ""; : LOCATE , 72: PRINT "";
'  COLOR 8: LOCATE 2, 1: PRINT ""; STRING$(78, ""); "";
'    LOCATE 24, 1: PRINT ""; STRING$(78, ""); "";
  COLOR 7: LOCATE 1, INT((80 - LEN(PNAME$)) / 2): PRINT PNAME$;
  COLOR 7: LOCATE 25, 2: PRINT " Ion2BBS v1.0.B ";
    LOCATE ,27: PRINT CHR$(16);" Copyright  {c} 2014  BJr ";CHR$(17);
'   LOCATE ,63: PRINT " Serial #";
'   COLOR 15: PRINT "146B200";  '                       *** Serial # ***
   LOCATE 3,1
 
300 VIEW PRINT 3 TO 23
  LOCATE 3, 1: COLOR 3
  Z$=PNAME$: GOSUB PROGLOG
  Z$="  Today is "
  Z$=Z$+MONTHTAB$(VAL(MID$(DATE$,1,2)))+STR$(VAL(MID$(DATE$,4,2)))
  A$="th": A=VAL(MID$(DATE$,4,2))
  IF A=1 OR A=21 OR A=31 THEN A$="st"
  IF A = 2 OR A = 22 THEN A$ = "nd"
  IF A = 3 OR A = 23 THEN A$ = "rd"
  Z$ = Z$ + A$ + ", " + MID$(DATE$, 7, 4): Z$ = Z$ + SPACE$(40 - LEN(Z$))
  Z$ = Z$ + "  It is now " + TIME$: A = VAL(MID$(TIME$, 1, 2))
  IF A > 11 THEN Z$ = Z$ + " Pm" ELSE Z$ = Z$ + " Am"
  GOSUB MESSAGE
  Z$ = "  Program.Log Bypassed"
  IF SYSLOG THEN Z$ = "  Program.Log Created"
  GOSUB MESSAGE
  PCOPY 1,0: SCREEN ,,0,0 ' Pop screen

START:
1000 PRINT
  FLNAME$="": FDESC$=""
  ECNT=0: RCNT=0: SCNT=0: COLOR 4

  OPEN "DESCRIPT.ION" FOR INPUT AS #1
  OPEN "FILES.BBS" FOR OUTPUT AS #2
  OPEN "FILESBBS.ERR" FOR OUTPUT AS #3

2000 NXTION:

  A$="": B$=""
  LINE INPUT#1, A$
  IF EOF(1) THEN GOTO FINISHED

  IF A$="" OR A$=" " THEN SCNT=SCNT+1: GOTO NXTION
  IF MID$(A$,1,1)=" " THEN GOSUB BADDESREC: GOTO NXTION

  FLNLEN=INSTR(A$," "): IF FLNLEN>1 THEN FLNLEN=FLNLEN-1 ELSE FLNLEN=LEN(A$)
  FLNAME$=MID$(A$,1,FLNLEN)

  FOR I=1 TO LEN(FLNAME$)
    C=ASC(MID$(FLNAME$,I,1))
    IF C>96 AND C<123 THEN MID$(FLNAME$,I,1)=CHR$(C-32) ' Force Uppercase
  NEXT I
  IF FLNAME$="FILES.BBS" THEN SCNT=SCNT+1: GOTO NXTION    ' Skip System/Control files
  IF FLNAME$="FILESBBS.ERR" THEN SCNT=SCNT+1: GOTO NXTION
  IF FLNAME$="FILES.FIX" THEN SCNT=SCNT+1: GOTO NXTION
  IF FLNAME$="INDEX.HTM" THEN SCNT=SCNT+1: GOTO NXTION
  IF FLNAME$="INDEX.HTML" THEN SCNT=SCNT+1: GOTO NXTION
  IF FLNAME$="DESCRIPT.ION" THEN SCNT=SCNT+1: GOTO NXTION

2010  OPEN FLNAME$ FOR INPUT AS #5      ' Validate existence
2020  CLOSE #5
  PRINT FLNAME$;" Validated."

  IF FLNLEN=LEN(A$) THEN GOSUB GO4ITFLN: GOTO NXTION

  B$=A$

'  TRUNC LEADING SPACES
  WHILE LEN(B$)>1 AND MID$(B$,1,1)=" ": B$=MID$(B$,2): WEND
  IF B$="" OR B$=" " THEN SCNT=SCNT+1: GOTO NXTION

  FDESC$=B$
  FLSPC$=""

  IF LEN(B$)<46 THEN GOSUB GO4ITDES: GOTO NXTION

NXTSPC:

  L=INSTR(FDESC$," ")
  IF L=0 OR L>45 THEN 
    RDESC$=MID$(FDESC$,46)
    FDESC$=MID$(FDESC$,1,45)
    GOSUB GO4ITDES
    FDESC$=RDESC$
   GOTO NXTSPC
  END IF
   
  LDESC$=MID$(FDESC$,1,L)
  RDESC$=MID$(FDESC$,L+1)
  LR=LEN(RDESC$): LL=LEN(LDESC$)

NXTDES:
  
  L=INSTR(RDESC$," ")
  IF L=0 AND LL+LR>45 THEN
    FDESC$=LDESC$
    GOSUB GO4ITDES
    FDESC$=RDESC$
    GOSUB GO4ITDES
    GOTO NXTION
  END IF
  IF L=0 THEN
    FDESC$=LDESC$+RDESC$
    GOSUB GO4ITDES
    GOTO NXTION
  END IF

  IF LL+L>45 THEN
    FDESC$=LDESC$
    GOSUB GO4ITDES
    FDESC$=RDESC$
    GOTO NXTSPC
  END IF 

  LDESC$=LDESC$+MID$(RDESC$,1,L): LL=LEN(LDESC$)
  RDESC$=MID$(RDESC$,L+1): LR=LEN(RDESC$)
  GOTO NXTDES

' TRUNCATE TRAILING SPACES AND CONCATENATE
'  WHILE MID$(B$,LEN(B$),1)=" ": B$=MID$(B$,1,LEN(B$)-1): WEND
'  IF FDESC$<>"" THEN FDESC$=FDESC$+" "+B$ ELSE FDESC$=B$  

  GOTO NXTION

GO4ITFLN:

  IF FLNAME$<>"" THEN 
    PRINT #2,FLNAME$
    RCNT=RCNT+1
   END IF
  FLNAME$=""
  RETURN

GO4ITDES:

  IF FDESC$<>"" THEN 
    PRINT #2,FLSPC$+FDESC$
    RCNT=RCNT+1
   END IF
  FDESC$="": FLSPC$=SPACE$(13)
  RETURN

BADIONREC:
  PRINT #3,FLNAME$+" not found"
'    PRINT FLNAME$;" ERRONEOUS!"

BADNXT:
  ECNT=ECNT+1
  FLNAME$=""
  RETURN
  
BADDESREC:
  PRINT #3,A$
  PRINT #3,"^ invalid data"
  GOTO BADNXT

  '  Code Here 
 
  ' Z$ = " Enter {Path}FileSpec of Input File [EXIT] ": GOSUB PROMPT
  ' IF A$ = "" THEN GOTO START
  ' IF A$ = "exit" OR A$ = "Exit" OR A$ = "EXIT" THEN GOTO FINISHED
  ERROR 123: REM Error Trap {Next line should NEVER be executed ...}
  GOTO FINISHED
5000 REM

PROGLOG:
  IF SYSLOG THEN PRINT #4, Z$
  RETURN
PROMPT:
  COLOR 7: PRINT Z$;: COLOR 15: INPUT A$
  IF SYSLOG THEN PRINT #4, Z$: PRINT #4, A$
  COLOR 3: RETURN
MESSAGE:
  IF SYSLOG THEN PRINT #4, Z$
  PRINT Z$: RETURN

3000 INTERROR:
  A=ERR: B=ERL: C=ERDEV
  IF A=75 AND ERL=2010 THEN GOSUB BADIONREC: RESUME NXTION
  IF A=53 AND ERL=2010 THEN GOSUB BADIONREC: RESUME NXTION

10000 SCREEN ,,0,0: PRINT
  SOUND 800, 4: SOUND 400, 2: SOUND 800, 8
  COLOR 14
  PRINT "  Internal Error";A;"  Line";B;"  Dev";C;" ";ERDEV$;" <Return>";
  A$="": WHILE A$="": A$=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED
' *** Debug
  SOUND 1000,2
  PRINT "Ok": A$="": WHILE A$="": A$=INKEY$: WEND
' *** Debug

FINISHED:
99999 ON ERROR GOTO XIT
'  GOSUB GO4IT
  COLOR 3: PRINT "===": PRINT "Total Records processed = ";RCNT
  COLOR 2: PRINT "Records skipped = ";SCNT
  COLOR 5: PRINT "Errors (see FILESBBS.ERR) = ";ECNT
  ENDOFRUN!=TIMER
  COLOR 11: PRINT "Elapsed Runtime = ";ENDOFRUN!-STARTOFRUN!;" seconds."
  Z$ = "": A = 0: COLOR 7
  IF COMMAND$="" THEN
    PRINT: PRINT "  Touch any key to Abort one minute Window"
    WHILE Z$ = "" AND TIMER < TIMEOUT
      Z$ = INKEY$
      IF TIMER >= A + 1 THEN LET A = TIMER: PRINT INT(TIMEOUT - A);
    WEND
    PRINT : PRINT
  END IF
  CLOSE ': SHELL "CLS"
XIT:
  SYSTEM

REM Month Table Data
  DATA January, February, March, April, May, June
  DATA July, August, September, October, November, December
REM *** End of Ion2BBS.Bas ***

